Index: /trunk/sources/HeuristicLab.Core.Views/3.3/OperatorLibraryView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/OperatorLibraryView.cs	(revision 2546)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/OperatorLibraryView.cs	(revision 2546)
@@ -0,0 +1,347 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Core.Views {
+  /// <summary>
+  /// Visual representation of the class <see cref="IOperatorLibrary"/>.
+  /// </summary>
+  [Content(typeof(OperatorLibrary), true)]
+  public partial class OperatorLibraryView : ItemViewBase {
+    private ChooseOperatorDialog chooseOperatorDialog;
+
+    /// <summary>
+    /// Gets or sets the operator library that should be displayed.
+    /// </summary>
+    /// <remarks>Uses property <see cref="ViewBase.Item"/> of base class <see cref="EditorBase"/>.</remarks>
+    public IOperatorLibrary OperatorLibrary {
+      get { return (IOperatorLibrary)Item; }
+      set { base.Item = value; }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="OperatorLibraryEditor"/> with caption 
+    /// <c>Operator Library</c>.
+    /// </summary>
+    public OperatorLibraryView() {
+      InitializeComponent();
+      operatorsTreeView.TreeViewNodeSorter = new NodeSorter();
+      Caption = "Operator Library";
+    }
+    /// <summary>
+    /// Initializes a new instance of <see cref="OperatorLibraryEditor"/> with the 
+    /// specified <paramref name="operatorLibrary"/>.
+    /// </summary>
+    /// <param name="operatorLibrary">The operator library to display.</param>
+    public OperatorLibraryView(IOperatorLibrary operatorLibrary)
+      : this() {
+      OperatorLibrary = operatorLibrary;
+    }
+
+    private class NodeSorter : IComparer {
+      public int Compare(object x, object y) {
+        TreeNode tx = x as TreeNode;
+        TreeNode ty = y as TreeNode;
+
+        int result = string.Compare(tx.Text, ty.Text);
+        if (result == 0)
+          result = tx.Index.CompareTo(ty.Index);
+        return result;
+      }
+    }
+
+    /// <summary>
+    /// Updates all controls with the latest data of the model.
+    /// </summary>
+    /// <remarks>Calls <see cref="EditorBase.UpdateControls"/> of base class <see cref="EditorBase"/>.</remarks>
+    protected override void UpdateControls() {
+      base.UpdateControls();
+      operatorsTreeView.Nodes.Clear();
+      addGroupButton.Enabled = false;
+      addOperatorButton.Enabled = false;
+      removeButton.Enabled = false;
+      if (OperatorLibrary == null) {
+        Caption = "Operator Library";
+        operatorsGroupBox.Enabled = false;
+      } else {
+        Caption = OperatorLibrary.Group.Name + " (" + OperatorLibrary.GetType().Name + ")";
+        operatorsGroupBox.Enabled = true;
+        operatorsTreeView.Nodes.Add(CreateTreeNode(OperatorLibrary.Group));
+        operatorsTreeView.Sort();
+      }
+    }
+
+    private TreeNode CreateTreeNode(IOperatorGroup group) {
+      TreeNode node = new TreeNode();
+      node.Text = group.Name;
+      node.ForeColor = Color.LightGray;
+      node.Tag = group;
+
+      foreach (IOperator op in group.Operators)
+        node.Nodes.Add(CreateTreeNode(op));
+      foreach (IOperatorGroup subGroup in group.SubGroups)
+        node.Nodes.Add(CreateTreeNode(subGroup));
+      return node;
+    }
+    private TreeNode CreateTreeNode(IOperator op) {
+      TreeNode node = new TreeNode();
+      node.Text = op.Name;
+      node.ToolTipText = op.GetType().Name;
+      node.Tag = op;
+      return node;
+    }
+    private void RemoveTreeNode(TreeNode node) {
+      if (node.Tag is IOperatorGroup) {
+        IOperatorGroup group = node.Tag as IOperatorGroup;
+        IOperatorGroup parent = node.Parent.Tag as IOperatorGroup;
+        parent.RemoveSubGroup(group);
+      } else if (node.Tag is IOperator) {
+        IOperator op = node.Tag as IOperator;
+        IOperatorGroup group = node.Parent.Tag as IOperatorGroup;
+        group.RemoveOperator(op);
+      }
+      node.Remove();
+      EnableDisableButtons();
+    }
+
+    private void EnableDisableButtons() {
+      addGroupButton.Enabled = false;
+      addOperatorButton.Enabled = false;
+      removeButton.Enabled = false;
+      operatorsTreeView.Focus();
+
+      if (operatorsTreeView.SelectedNode != null) {
+        if (operatorsTreeView.SelectedNode.Parent != null)
+          removeButton.Enabled = true;
+        if (operatorsTreeView.SelectedNode.Tag is IOperatorGroup) {
+          addGroupButton.Enabled = true;
+          addOperatorButton.Enabled = true;
+        }
+      }
+    }
+
+    private void MergeOperatorLibrary(IOperatorGroup src, IOperatorGroup dest) {
+      foreach(IOperator op in src.Operators) {
+        if(!Contains(dest, op)) {
+          dest.AddOperator(op);
+        }
+      }
+
+      foreach(OperatorGroup group in src.SubGroups) {
+        bool mergedIntoExistingGroup = false;
+        // try to find a group in dest with matching name
+        foreach(OperatorGroup destGroup in dest.SubGroups) {
+          if(group.Name == destGroup.Name) {
+            MergeOperatorLibrary(group, destGroup);
+            mergedIntoExistingGroup = true;
+            break;
+          }
+        }
+        if(!mergedIntoExistingGroup) {
+          OperatorGroup newGroup = new OperatorGroup();
+          newGroup.Name = group.Name;
+          dest.AddSubGroup(newGroup);
+          MergeOperatorLibrary(group, newGroup);
+        }
+      }
+    }
+
+    private bool Contains(IOperatorGroup group, IOperator op) {
+      foreach(IOperator destOp in group.Operators) {
+        if(op.Name == destOp.Name) {
+          return true;
+        }
+      }
+      return false;
+    }
+
+
+    #region TreeView Events
+    private void operatorsTreeView_AfterSelect(object sender, TreeViewEventArgs e) {
+      EnableDisableButtons();
+    }
+    private void operatorsTreeView_AfterLabelEdit(object sender, NodeLabelEditEventArgs e) {
+      e.CancelEdit = false;
+
+      string name = e.Label;
+      if (name != null) {
+        if (e.Node.Tag is IOperatorGroup)
+          ((IOperatorGroup)e.Node.Tag).Name = name;
+        else if (e.Node.Tag is IOperator)
+          ((IOperator)e.Node.Tag).Name = name;
+      }
+    }
+    private void operatorsTreeView_DoubleClick(object sender, EventArgs e) {
+      if (operatorsTreeView.SelectedNode != null) {
+        IOperator op = operatorsTreeView.SelectedNode.Tag as IOperator;
+        if (op != null) {
+          IView view = MainFormManager.CreateDefaultView(op);
+          if (view != null) MainFormManager.MainForm.ShowView(view);
+        }
+      }
+    }
+    #endregion
+
+    #region Button Events
+    private void addOperatorButton_Click(object sender, EventArgs e) {
+      if (chooseOperatorDialog == null) chooseOperatorDialog = new ChooseOperatorDialog();
+      if (chooseOperatorDialog.ShowDialog(this) == DialogResult.OK) {
+        TreeNode node = operatorsTreeView.SelectedNode;
+        IOperatorGroup group = node.Tag as IOperatorGroup;
+        group.AddOperator(chooseOperatorDialog.Operator);
+        node.Nodes.Add(CreateTreeNode(chooseOperatorDialog.Operator));
+        operatorsTreeView.Sort();
+        EnableDisableButtons();
+      }
+    }
+    private void addGroupButton_Click(object sender, EventArgs e) {
+      TreeNode node = operatorsTreeView.SelectedNode;
+      IOperatorGroup newGroup = new OperatorGroup();
+      IOperatorGroup group = node.Tag as OperatorGroup;
+      group.AddSubGroup(newGroup);
+      node.Nodes.Add(CreateTreeNode(newGroup));
+      operatorsTreeView.Sort();
+      EnableDisableButtons();
+    }
+    private void removeButton_Click(object sender, EventArgs e) {
+      TreeNode node = operatorsTreeView.SelectedNode;
+      RemoveTreeNode(node);
+    }
+    private void importButton_Click(object sender, EventArgs e) {
+      if(openFileDialog.ShowDialog() == DialogResult.OK) {
+        IOperatorLibrary loadedLibrary = (PersistenceManager.Load(openFileDialog.FileName) as IOperatorLibrary);
+        if(loadedLibrary == null) {
+          Auxiliary.ShowErrorMessageBox("The selected file does not contain an operator library");
+        } else {
+          MergeOperatorLibrary(loadedLibrary.Group, OperatorLibrary.Group);
+          Refresh();
+        }
+      }
+    }
+    #endregion
+
+    #region Key Events
+    private void operatorsTreeView_KeyDown(object sender, KeyEventArgs e) {
+      TreeNode node = operatorsTreeView.SelectedNode;
+      if ((e.KeyCode == Keys.Delete) && (node != null) && (node.Parent != null))
+        RemoveTreeNode(operatorsTreeView.SelectedNode);
+      if ((e.KeyCode == Keys.F2) && (node != null))
+        node.BeginEdit();
+    }
+    #endregion
+
+
+    #region Mouse Events
+    private void operatorsTreeView_MouseDown(object sender, MouseEventArgs e) {
+      if (e.Button != MouseButtons.Right) return;
+      TreeNode clickedNode = operatorsTreeView.GetNodeAt(e.X, e.Y);
+      if (clickedNode != null) {
+        operatorsTreeView.SelectedNode = clickedNode;
+        operatorsTreeView.Refresh();
+      }
+    }
+    #endregion
+
+
+    #region Context Menu Events
+    private void contextMenuStrip_Opening(object sender, CancelEventArgs e) {
+      viewToolStripMenuItem.Enabled = false;
+      if (operatorsTreeView.SelectedNode != null) {
+        IOperator op = operatorsTreeView.SelectedNode.Tag as IOperator;
+        if (op != null) {
+          IItemView view = (IItemView)MainFormManager.CreateDefaultView(op);
+          if (view != null) {
+            viewToolStripMenuItem.Enabled = true;
+            viewToolStripMenuItem.Tag = view;
+          }
+        }
+      }
+    }
+    private void viewToolStripMenuItem_Click(object sender, EventArgs e) {
+      IView view = viewToolStripMenuItem.Tag as IView;
+      if (view != null) MainFormManager.MainForm.ShowView(view);
+    }
+    #endregion
+
+    #region Drag and Drop Events
+    private void operatorsTreeView_ItemDrag(object sender, ItemDragEventArgs e) {
+      TreeNode node = (TreeNode)e.Item;
+      IOperator op = node.Tag as IOperator;
+      if (op != null) {
+        DataObject data = new DataObject();
+        data.SetData("IOperator", op);
+        data.SetData("DragSource", operatorsTreeView);
+        DoDragDrop(data, DragDropEffects.Copy);
+      }
+    }
+    private void operatorsTreeView_DragEnter(object sender, DragEventArgs e) {
+      e.Effect = DragDropEffects.None;
+      if (e.Data.GetDataPresent("IOperator")) {
+        Point p = operatorsTreeView.PointToClient(new Point(e.X, e.Y));
+        TreeNode node = operatorsTreeView.GetNodeAt(p);
+        if ((node != null) && (node.Tag is IOperatorGroup))
+          e.Effect = DragDropEffects.Copy;
+      }
+    }
+    private void operatorsTreeView_DragOver(object sender, DragEventArgs e) {
+      e.Effect = DragDropEffects.None;
+      if (e.Data.GetDataPresent("IOperator")) {
+        Point p = operatorsTreeView.PointToClient(new Point(e.X, e.Y));
+        TreeNode node = operatorsTreeView.GetNodeAt(p);
+        if ((node != null) && (node.Tag is IOperatorGroup))
+          e.Effect = DragDropEffects.Copy;
+      }
+    }
+    private void operatorsTreeView_DragDrop(object sender, DragEventArgs e) {
+      if (e.Effect != DragDropEffects.None) {
+        if (e.Data.GetDataPresent("IOperator")) {
+          IOperator op = (IOperator)e.Data.GetData("IOperator");
+          Point p = operatorsTreeView.PointToClient(new Point(e.X, e.Y));
+          TreeNode node = operatorsTreeView.GetNodeAt(p);
+          if (node != null) {
+            op = (IOperator)op.Clone();
+
+            while (op.SubOperators.Count > 0)
+              op.RemoveSubOperator(0);
+
+            IOperatorGroup group = (IOperatorGroup)node.Tag;
+            group.AddOperator(op);
+            node.Nodes.Add(CreateTreeNode(op));
+            operatorsTreeView.Sort();
+            EnableDisableButtons();
+          }
+        }
+      }
+    }
+    #endregion
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ScopeView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ScopeView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ScopeView.cs	(revision 2546)
@@ -36,5 +36,5 @@
   /// </summary>
   [Content(typeof(Scope), true)]
-  public partial class ScopeView : ViewBase {
+  public partial class ScopeView : ItemViewBase {
     private Dictionary<IScope, TreeNode> scopeNodeTable;
     private Dictionary<IScope, bool> scopeExpandedTable;
@@ -133,5 +133,5 @@
       if(scopesTreeView.SelectedNode != null && scopesTreeView.SelectedNode.Tag != null) {
         IScope scope = (IScope)scopesTreeView.SelectedNode.Tag;
-        PluginManager.ControlManager.ShowControl(new VariablesScopeView(scope));
+        MainFormManager.MainForm.ShowView(new VariablesScopeView(scope));
       }
     }
@@ -201,9 +201,10 @@
     private void variablesToolStripMenuItem_Click(object sender, EventArgs e) {
       IScope scope = (IScope)scopesTreeView.SelectedNode.Tag;
-      PluginManager.ControlManager.ShowControl(new VariablesScopeView(scope));
+      MainFormManager.MainForm.ShowView(new VariablesScopeView(scope));
     }
     private void showViewToolStripMenuItem_Click(object sender, EventArgs e) {
       IItem item = (IItem)((ToolStripMenuItem)sender).Tag;
-      PluginManager.ControlManager.ShowControl((IControl)MainFormManager.CreateDefaultView(item));
+      IView view = MainFormManager.CreateDefaultView(item);
+      if (view != null) MainFormManager.MainForm.ShowView(view);
     }
     #endregion
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/VariableInfoView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/VariableInfoView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/VariableInfoView.cs	(revision 2546)
@@ -34,5 +34,5 @@
   /// </summary>
   [Content(typeof(VariableInfo), true)]
-  public partial class VariableInfoView : ViewBase {
+  public partial class VariableInfoView : ItemViewBase {
     /// <summary>
     /// Gets or sets the variable information to represent visually.
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs	(revision 2546)
@@ -34,5 +34,5 @@
   /// </summary>
   [Content(typeof(Variable), true)]
-  public partial class VariableView : ViewBase {
+  public partial class VariableView : ItemViewBase {
     private ChooseItemDialog chooseItemDialog;
 
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/VariablesScopeView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/VariablesScopeView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/VariablesScopeView.cs	(revision 2546)
@@ -35,5 +35,5 @@
   /// </summary>
   [Content(typeof(Scope))]
-  public partial class VariablesScopeView : ViewBase {
+  public partial class VariablesScopeView : ItemViewBase {
     private ChooseItemDialog chooseItemDialog;
 
Index: /trunk/sources/HeuristicLab.Core/3.3/Attributes/CreatableAttribute.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Attributes/CreatableAttribute.cs	(revision 2546)
+++ /trunk/sources/HeuristicLab.Core/3.3/Attributes/CreatableAttribute.cs	(revision 2546)
@@ -0,0 +1,58 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+
+namespace HeuristicLab.Core {
+  [AttributeUsage(AttributeTargets.Class, AllowMultiple = false, Inherited = false)]
+  public sealed class CreatableAttribute : Attribute {
+    private string category;
+    public string Category {
+      get {
+        return category;
+      }
+      set {
+        if (value == null) throw new ArgumentNullException("Category", "CreataleAttribute.Category must not be null");
+        category = value;
+      }
+    }
+
+    public CreatableAttribute() {
+      Category = "Other Items";
+    }
+    public CreatableAttribute(string category)
+      : this() {
+      Category = category;
+    }
+
+    public static bool IsCreatable(Type type) {
+      object[] attribs = type.GetCustomAttributes(typeof(CreatableAttribute), false);
+      return attribs.Length > 0;
+    }
+    public static string GetCategory(Type type) {
+      object[] attribs = type.GetCustomAttributes(typeof(CreatableAttribute), false);
+      if (attribs.Length > 0) return ((CreatableAttribute)attribs[0]).Category;
+      else return null;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/Attributes/ItemAttribute.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Attributes/ItemAttribute.cs	(revision 2546)
+++ /trunk/sources/HeuristicLab.Core/3.3/Attributes/ItemAttribute.cs	(revision 2546)
@@ -0,0 +1,54 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Resources;
+using System.Drawing;
+
+namespace HeuristicLab.Core {
+  [AttributeUsage(AttributeTargets.Class, AllowMultiple = false, Inherited = false)]
+  public sealed class ItemAttribute : Attribute {
+    public string Name { get; set; }
+    public string Description { get; set; }
+
+    public ItemAttribute() {
+      Name = null;
+      Description = null;
+    }
+    public ItemAttribute(string name, string description) {
+      Name = name;
+      Description = description;
+    }
+
+    public static string GetName(Type type) {
+      object[] attribs = type.GetCustomAttributes(typeof(ItemAttribute), true);
+      if (attribs.Length > 0) return ((ItemAttribute)attribs[0]).Name;
+      else return null;
+    }
+    public static string GetDescription(Type type) {
+      object[] attribs = type.GetCustomAttributes(typeof(ItemAttribute), true);
+      if (attribs.Length > 0) return ((ItemAttribute)attribs[0]).Description;
+      else return null;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 2545)
+++ /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 2546)
@@ -95,12 +95,14 @@
     </Reference>
     <Reference Include="System.Data" />
+    <Reference Include="System.Drawing" />
     <Reference Include="System.Xml" />
   </ItemGroup>
   <ItemGroup>
     <Compile Include="AtomicOperation.cs" />
+    <Compile Include="Attributes\ItemAttribute.cs" />
     <Compile Include="CompositeOperation.cs" />
     <Compile Include="Cloner.cs" />
+    <Compile Include="Attributes\CreatableAttribute.cs" />
     <Compile Include="Interfaces\ICloner.cs" />
-    <Compile Include="Interfaces\IEditable.cs" />
     <Compile Include="Interfaces\IOperation.cs" />
     <Compile Include="Interfaces\IOperatorLibrary.cs" />
@@ -136,4 +138,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Common.Resources\3.2\HeuristicLab.Common.Resources-3.2.csproj">
+      <Project>{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}</Project>
+      <Name>HeuristicLab.Common.Resources-3.2</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Common\3.2\HeuristicLab.Common-3.2.csproj">
       <Project>{1FC004FC-59AF-4249-B1B6-FF25873A20E4}</Project>
Index: /trunk/sources/HeuristicLab.Core/3.3/HeuristicLabCorePlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/HeuristicLabCorePlugin.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Core/3.3/HeuristicLabCorePlugin.cs	(revision 2546)
@@ -32,4 +32,5 @@
   [PluginFile(Filename = "HeuristicLab.Core-3.3.dll", Filetype = PluginFileType.Assembly)]
   [Dependency(Dependency = "HeuristicLab.Common-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Common.Resources-3.2")]
   [Dependency(Dependency = "HeuristicLab.Persistence-3.3")]
   public class HeuristicLabCorePlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IItem.cs	(revision 2546)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using System.Text;
+using System.Drawing;
 
 namespace HeuristicLab.Core {
@@ -29,4 +30,8 @@
   /// </summary>
   public interface IItem : ICloneable {
+    string Name { get; }
+    string Description { get; }
+    Image Image { get; }
+
     /// <summary>
     /// Creates a deep clone of this item.
Index: /trunk/sources/HeuristicLab.Core/3.3/ItemBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ItemBase.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Core/3.3/ItemBase.cs	(revision 2546)
@@ -24,5 +24,8 @@
 using System.Text;
 using System.Xml;
+using System.Drawing;
+using System.Resources;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.Core {
@@ -30,6 +33,27 @@
   /// Represents the base class for all basic item types.
   /// </summary>
+  [Item("ItemBase", "Base class for all HeuristicLab items.")]
   [EmptyStorableClass]
   public abstract class ItemBase : IItem {
+    public virtual string Name {
+      get {
+        if (ItemAttribute.GetName(this.GetType()) != null)
+          return ItemAttribute.GetName(this.GetType());
+        else
+          return this.GetType().Name;
+      }
+    }
+    public virtual string Description {
+      get {
+        if (ItemAttribute.GetDescription(this.GetType()) != null)
+          return ItemAttribute.GetDescription(this.GetType());
+        else
+          return "No description available.";
+      }
+    }
+    public virtual Image Image {
+      get { return Resources.HeuristicLab; }
+    }
+
     /// <summary>
     /// Creates a deep clone of this instance.
Index: /trunk/sources/HeuristicLab.Core/3.3/OperatorLibrary.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/OperatorLibrary.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Core/3.3/OperatorLibrary.cs	(revision 2546)
@@ -30,4 +30,6 @@
   /// Represents a library of operators consisting of one <see cref="IOperatorGroup"/>.
   /// </summary>
+  [Creatable("Libraries")]
+  [Item("Operator Library", "A library that contains multiple operators.")]
   public class OperatorLibrary : ItemBase, IOperatorLibrary {
 
Index: /trunk/sources/HeuristicLab.Core/3.3/PersistenceManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/PersistenceManager.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Core/3.3/PersistenceManager.cs	(revision 2546)
@@ -36,5 +36,5 @@
   public static class PersistenceManager {
     /// <summary>
-    /// Saves the specified <paramref name="instance"/> in the specified file through creating an 
+    /// Saves the specified <paramref name="instance"/> in th specified file through creating an 
     /// <see cref="XmlDocument"/>.
     /// </summary>
@@ -78,35 +78,4 @@
       return (IItem)XmlParser.Deserialize(stream);
     }
-
-    /// <summary>
-    /// Builds a meaningful string for the given <paramref name="type"/> with the namespace information, 
-    /// all its arguments, the assembly name...
-    /// </summary>
-    /// <param name="type">The type for which a string should be created.</param>
-    /// <returns>A string value of this type containing different additional information.</returns>
-    public static string BuildTypeString(Type type) {
-      string assembly = type.Assembly.FullName;
-      assembly = assembly.Substring(0, assembly.IndexOf(", "));
-
-      StringBuilder builder = new StringBuilder();
-      builder.Append(type.Namespace);
-      builder.Append(".");
-      builder.Append(type.Name);
-      Type[] args = type.GetGenericArguments();
-      if (args.Length > 0) {
-        builder.Append("[[");
-        builder.Append(BuildTypeString(args[0]));
-        builder.Append("]");
-        for (int i = 1; i < args.Length; i++) {
-          builder.Append(",[");
-          builder.Append(BuildTypeString(args[i]));
-          builder.Append("]");
-        }
-        builder.Append("]");
-      }
-      builder.Append(", ");
-      builder.Append(assembly);
-      return builder.ToString();
-    }
   }
 }
Index: /trunk/sources/HeuristicLab.Data/3.3/ArrayDataBaseView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/ArrayDataBaseView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Data/3.3/ArrayDataBaseView.cs	(revision 2546)
@@ -34,5 +34,5 @@
   /// The visual representation of the class <see cref="ArrayDataBase"/>.
   /// </summary>
-  public partial class ArrayDataBaseView : ViewBase {
+  public partial class ArrayDataBaseView : ItemViewBase {
     /// <summary>
     /// Gets or sets the instance of the array to represent.
Index: /trunk/sources/HeuristicLab.Data/3.3/BoolDataView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/BoolDataView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Data/3.3/BoolDataView.cs	(revision 2546)
@@ -36,5 +36,5 @@
   /// </summary>
   [Content(typeof(BoolData), true)]
-  public partial class BoolDataView : ViewBase {
+  public partial class BoolDataView : ItemViewBase {
     /// <summary>
     /// Gets or sets the boolean value to represent visually.
Index: /trunk/sources/HeuristicLab.Data/3.3/DoubleDataView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/DoubleDataView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Data/3.3/DoubleDataView.cs	(revision 2546)
@@ -36,5 +36,5 @@
   /// </summary>
   [Content(typeof(DoubleData), true)]
-  public partial class DoubleDataView : ViewBase {
+  public partial class DoubleDataView : ItemViewBase {
     /// <summary>
     /// Gets or sets the double value to represent visually.
Index: /trunk/sources/HeuristicLab.Data/3.3/IntDataView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/IntDataView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Data/3.3/IntDataView.cs	(revision 2546)
@@ -36,5 +36,5 @@
   /// </summary>
   [Content(typeof(IntData), true)]
-  public partial class IntDataView : ViewBase {
+  public partial class IntDataView : ItemViewBase {
     /// <summary>
     /// Gets or set the int value to represent visually.
Index: /trunk/sources/HeuristicLab.Data/3.3/ItemDictionaryView_T.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/ItemDictionaryView_T.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Data/3.3/ItemDictionaryView_T.cs	(revision 2546)
@@ -18,5 +18,5 @@
   /// <typeparam name="V">The type of the values of the dictionary.</typeparam>
   [Content(typeof(ItemDictionary<IItem, IItem>), true)]
-  public partial class ItemDictionaryView<K, V> : ViewBase
+  public partial class ItemDictionaryView<K, V> : ItemViewBase
     where K : IItem
     where V : IItem {
Index: /trunk/sources/HeuristicLab.Data/3.3/ItemListView_T.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/ItemListView_T.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Data/3.3/ItemListView_T.cs	(revision 2546)
@@ -37,5 +37,5 @@
   /// </summary>
   /// <typeparam name="T">The type of the items in the list.</typeparam>
-  public partial class ItemListView<T> : ViewBase where T : IItem {
+  public partial class ItemListView<T> : ItemViewBase where T : IItem {
     private ChooseItemDialog chooseItemDialog;
 
Index: /trunk/sources/HeuristicLab.Data/3.3/MatrixDataBaseView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/MatrixDataBaseView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Data/3.3/MatrixDataBaseView.cs	(revision 2546)
@@ -34,5 +34,5 @@
   /// The basic visual representation of a two-dimensional matrix.
   /// </summary>
-  public partial class MatrixDataBaseView : ViewBase {
+  public partial class MatrixDataBaseView : ItemViewBase {
 
     /// <summary>
